/** Determines the available boolean operators for a certain datatype. */
export function GetAttributeBoolOperators(
  datatype: string
): { label: string; value: string }[] {
  switch (datatype) {
    case 'text':
    case 'string':
      return [
        {
          label: '=',
          value: 'EQ',
        },
        {
          label: '≠',
          value: 'NEQ',
        },
        {
          label: 'inc',
          value: 'includes',
        },
        {
          label: 'exc',
          value: 'excludes',
        },
      ];
    case 'int':
    case 'float':
      return [
        {
          label: '=',
          value: 'EQ',
        },
        {
          label: '≠',
          value: 'NEQ',
        },
        {
          label: '>',
          value: 'GT',
        },
        {
          label: '≥',
          value: 'GTE',
        },
        {
          label: '<',
          value: 'LT',
        },
        {
          label: '≤',
          value: 'LTE',
        },
      ];
    case 'bool':
    default:
      return [
        {
          label: '=',
          value: 'EQ',
        },
      ];
  }
}
